package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type place struct {
	Table
	user   user
	city   city
	street street
}

func (s place) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.CITY_NAME:
		if m.Option(ctx.ACTION) == "placeCreate" {
			break
		}
		m.Cmdy(s.city, s.city.Select).CutTo(model.NAME, arg[0])
	case model.STREET_NAME:
		if m.Option(ctx.ACTION) == "placeCreate" {
			break
		}
		m.Cmdy(s.street, s.street.Select).CutTo(model.NAME, arg[0])
	case model.PLACE_TYPE:
		for k, v := range PlaceTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s place) User(m *ice.Message, arg ...string) {
	userPlace := userPlace{}
	s.Tables(m, "left join user_places on places.uid = user_places.place_uid", s.user).Fields(m,
		s.Key(userPlace, model.CREATED_AT), s.Key(userPlace, model.UID),
		model.USER_AVATAR, model.USER_NAME, model.USER_PLACE_ROLE, model.BEGIN_TIME, model.END_TIME,
	).Orders(m, s.Desc(model.CREATED_AT))
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m)
		}
	} else if len(arg) == 1 {
		s.Select(m, model.PLACE_UID, arg[0])
	} else {
		s.Select(m.FieldsSetDetail(), s.Key(userPlace, model.UID), arg[1])
	}
	s.RewriteAppend(m)
}
func init() { ice.TeamCtxCmd(place{}) }

type Place struct{ place }

func init() { ice.TeamCtxCmd(Place{}) }

type PlaceType int

const (
	PlaceHouse PlaceType = iota
	PlaceHotel
	PlaceStore
	PlacePublic
	PlaceSchool
	PlaceOffice
	PlaceFactory
	PlaceHospital
)

var PlaceTypeList = map[PlaceType]string{
	PlaceHouse:    "house",
	PlaceHotel:    "hotel",
	PlaceStore:    "store",
	PlacePublic:   "public",
	PlaceSchool:   "school",
	PlaceOffice:   "office",
	PlaceFactory:  "factory",
	PlaceHospital: "hospital",
}

func (s PlaceType) String() string { return PlaceTypeList[s] }
