package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type userPlace struct {
	Table
	place  place
	street street
	city   city
	create string `name:"create user_uid* place_uid* role* begin_time end_time"`
	list   string `name:"list user_uid place_uid auto"`
}

func (s userPlace) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.place, s.street, s.city).Fields(m, "user_places.created_at", "user_places.id",
		model.PLACE_NAME, model.PLACE_TYPE, model.USER_PLACE_ROLE,
		model.CITY_NAME, model.STREET_NAME, model.PLACE_ADDRESS,
		model.USER_UID, model.PLACE_UID,
	).Orders(m, "created_at DESC")
	if len(arg) == 0 {
		if m.IsTech() {
			s.Select(m)
		}
	} else if len(arg) == 1 {
		s.Select(m, model.USER_UID, arg[0])
	} else {
		s.Select(m.FieldsSetDetail(), model.PLACE_UID, arg[1])
	}
	s.RewriteAppend(m)
}

func init() { ice.TeamCtxCmd(userPlace{}) }

type UserPlace struct{ userPlace }

func init() { ice.TeamCtxCmd(UserPlace{}) }

type UserPlaceRole int

const (
	UserPlaceCreator UserPlaceRole = iota
	UserPlaceLandlord
	UserPlaceTenant
	UserPlaceAdmin
	UserPlaceVisitor
)

var UserPlaceRoleList = map[UserPlaceRole]string{
	UserPlaceCreator:  "creator",
	UserPlaceLandlord: "landlord",
	UserPlaceTenant:   "tenant",
	UserPlaceAdmin:    "admin",
	UserPlaceVisitor:  "visitor",
}

func (s UserPlaceRole) String() string { return UserPlaceRoleList[s] }
